diff --git a/test/unit/service_test.rb b/test/unit/service_test.rb
new file mode 100644
index 000000000..3d2d98bcd
--- /dev/null
+++ b/test/unit/service_test.rb
@@ -0,0 +1,195 @@
+# frozen_string_literal: true
+
+require_relative "../test_helper"
+require "hive/service"
+
+# OS-registered daemon service (plan: install/packaging U4).
+#
+# Pins the unit-file generation (plist + systemd), the register/enable/
+# start/stop/remove command assembly (via the injectable runner), the
+# supervised-env marker, and the never-silent-autostart contract.
+class ServiceTest < Minitest::Test
+  SERVICE_ENV = %w[HIVE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_STATE_HOME XDG_CACHE_HOME HOME HIVE_SERVICE_BINARY HIVE_DAEMON_SERVICE].freeze
+
+  def with_clean_env
+    saved = {}
+    SERVICE_ENV.each { |v| saved[v] = ENV[v] }
+    SERVICE_ENV.each { |v| ENV.delete(v) }
+    yield
+  ensure
+    saved.each { |v, val| val.nil? ? ENV.delete(v) : ENV[v] = val }
+  end
+
+  # Override the OS detection singleton methods for one block. macos? and
+  # linux? are module_functions, so they live on the singleton class.
+  def with_os(macos:, linux:)
+    singleton = Hive::Service.singleton_class
+    singleton.send(:alias_method, :__svc_orig_macos, :macos?)
+    singleton.send(:alias_method, :__svc_orig_linux, :linux?)
+    singleton.send(:define_method, :macos?) { macos }
+    singleton.send(:define_method, :linux?) { linux }
+    yield
+  ensure
+    singleton.send(:alias_method, :macos?, :__svc_orig_macos)
+    singleton.send(:alias_method, :linux?, :__svc_orig_linux)
+    singleton.send(:remove_method, :__svc_orig_macos)
+    singleton.send(:remove_method, :__svc_orig_linux)
+  end
+
+  def capture_runner
+    commands = []
+    Hive::Service.runner = ->(*cmd) { commands << cmd; true }
+    yield commands
+  ensure
+    Hive::Service.runner = nil
+  end
+
+  def test_supervised_marker_env
+    with_clean_env do
+      refute Hive::Service.supervised?
+      ENV["HIVE_DAEMON_SERVICE"] = "1"
+      assert Hive::Service.supervised?
+    end
+  end
+
+  def test_render_unit_contains_binary_and_supervised_marker
+    with_clean_env do
+      unit = Hive::Service.render_unit("/opt/bin/hive")
+      assert_includes unit, "ExecStart=/opt/bin/hive daemon start"
+      assert_includes unit, "Environment=HIVE_DAEMON_SERVICE=1"
+      assert_includes unit, "[Install]"
+    end
+  end
+
+  def test_render_plist_contains_binary_and_supervised_marker
+    with_clean_env do
+      plist = Hive::Service.render_plist("/opt/bin/hive")
+      assert_includes plist, "<string>/opt/bin/hive</string>"
+      assert_includes plist, "<key>HIVE_DAEMON_SERVICE</key>"
+      assert_includes plist, "<key>Label</key>"
+    end
+  end
+
+  def test_register_writes_systemd_unit_on_linux
+    Dir.mktmpdir("hive-svc") do |home|
+      with_clean_env do
+        ENV["HOME"] = home
+        path = Hive::Service.register!(binary: "/opt/bin/hive")
+        assert_equal File.join(home, ".config/systemd/user/hive-daemon.service"), path
+        assert File.exist?(path)
+        assert_includes File.read(path), "ExecStart=/opt/bin/hive daemon start"
+      end
+    end
+  end
+
+  def test_register_writes_plist_on_macos
+    Dir.mktmpdir("hive-svc") do |home|
+      with_clean_env do
+        ENV["HOME"] = home
+        with_os(macos: true, linux: false) do
+          path = Hive::Service.register!(binary: "/opt/bin/hive")
+          assert_equal File.join(home, "Library/LaunchAgents/local.hive-daemon.plist"), path
+          assert File.exist?(path)
+          assert_includes File.read(path), "<string>/opt/bin/hive</string>"
+        end
+      end
+    end
+  end
+
+  def test_registered_is_false_when_no_unit_file
+    Dir.mktmpdir("hive-svc") do |home|
+      with_clean_env do
+        ENV["HOME"] = home
+        refute Hive::Service.registered?
+      end
+    end
+  end
+
+  def test_remove_is_idempotent_and_deletes_unit
+    Dir.mktmpdir("hive-svc") do |home|
+      with_clean_env do
+        ENV["HOME"] = home
+        refute Hive::Service.remove!, "nothing to remove"
+
+        Hive::Service.register!(binary: "/opt/bin/hive")
+        assert Hive::Service.registered?
+        assert Hive::Service.remove!
+        refute File.exist?(Hive::Service.systemd_unit_path)
+      end
+    end
+  end
+
+  def test_enable_and_start_command_assembly_on_linux
+    Dir.mktmpdir("hive-svc") do |home|
+      with_clean_env do
+        ENV["HOME"] = home
+        Hive::Service.register!(binary: "/opt/bin/hive")
+
+        capture_runner do |commands|
+          Hive::Service.enable!
+          Hive::Service.start!
+          Hive::Service.stop!
+          assert_equal %w[systemctl --user daemon-reload], commands[0]
+          assert_equal %w[systemctl --user enable hive-daemon], commands[1]
+          assert_equal %w[systemctl --user start hive-daemon], commands[2]
+          assert_equal %w[systemctl --user stop hive-daemon], commands[3]
+        end
+      end
+    end
+  end
+
+  def test_enable_command_assembly_on_macos
+    Dir.mktmpdir("hive-svc") do |home|
+      with_clean_env do
+        ENV["HOME"] = home
+        with_os(macos: true, linux: false) do
+          capture_runner do |commands|
+            Hive::Service.enable!
+            assert_equal [ "launchctl", "load", File.join(home, "Library/LaunchAgents/local.hive-daemon.plist") ], commands[0]
+          end
+        end
+      end
+    end
+  end
+
+  def test_unsupported_os_raises_on_register
+    with_os(macos: false, linux: false) do
+      assert_raises(Hive::Error) { Hive::Service.register!(binary: "/opt/bin/hive") }
+    end
+  end
+
+  def test_supervised_process_skips_delegation
+    # The dispatcher body is marked supervised so `hive daemon start` exec'd
+    # by the supervisor runs in the foreground. `supervised?` is true only
+    # with the marker env; the flag never leaks across tests.
+    with_clean_env do
+      ENV["HIVE_DAEMON_SERVICE"] = "1"
+      assert Hive::Service.supervised?
+    end
+    with_clean_env do
+      refute Hive::Service.supervised?
+    end
+  end
+
+  def test_launchd_pid_parses_plist_running
+    output = "{\n\t\"Label\" = \"local.hive-daemon\";\n\t\"PID\" = 4242;\n};\n"
+    assert_equal 4242, Hive::Service.launchd_pid(output)
+  end
+
+  def test_launchd_pid_parses_plist_loaded_but_not_running
+    # `launchctl list` exits 0 for a merely-LOADED job and reports PID -1;
+    # the old `exit status == running` logic reported this as running.
+    output = "{\n\t\"Label\" = \"local.hive-daemon\";\n\t\"PID\" = -1;\n};\n"
+    assert_equal(-1, Hive::Service.launchd_pid(output))
+  end
+
+  def test_launchd_pid_parses_classic_table
+    output = "PID\tStatus\tLabel\n123\t0\tlocal.hive-daemon\n"
+    assert_equal 123, Hive::Service.launchd_pid(output)
+  end
+
+  def test_launchd_pid_returns_nil_when_no_pid
+    assert_nil Hive::Service.launchd_pid("")
+    assert_nil Hive::Service.launchd_pid(nil)
+  end
+end
